package com.eactive.eai.batch.job.jobItem.ftbat;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_FTBAT_0230 extends DefaultTelegram implements TelegramService
{

    /**
     * 생성자
     */
    public SEND_FTBAT_0230() {
        //결번확인요구
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            byte[] som = new byte[1];
            byte[] eom = new byte[1];
            som[0] = 0x02;
            eom[0] = 0x03;

            //메시지 시작 문자
            al_Field.set(0, som);

            //메시지 타입
            compileField(1, this.getFldTelegramType(), this.al_FieldProps[1]);

            compileField(2, ""+batchDoc.getBatchMsg().getHeader().getFileSize(), this.al_FieldProps[2]);

            //실 DATA BYTE 수
            compileField(3, "0000", this.al_FieldProps[3]);

            compileField(4, "", this.al_FieldProps[4]);

            compileField(5, "", this.al_FieldProps[5]);

            //메시지 종료 문자
            al_Field.set(6, eom);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=1; i<2; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=2; i< al_Field.size()-2; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            //송신 파일 End DB로그
            LogUtil.setLogFileEnd(batchDoc);

            int sleepTime = 1000;
            try {
				sleepTime = Integer.parseInt(getTelegramInfo().getProperty(TelegramKeys.SLEEP_TIME_POST));
			} catch (Exception e) {}
            try {
				Thread.sleep(sleepTime); 
			} catch (Exception e) {}

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            try {
				Thread.sleep(300); 
			} catch (Exception e) {}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength(){
    	return 1024;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType(){
        return super.getFieldValueString(1);
    }
}